import * as React from 'react';
import { View } from 'react-native';
import { getColor } from './style-utils';
import Text from './text';

export const Badge = ({
  variant = 'dot',
  dotPosition = 'absolute top-0 right-0',
  count = 1,
  color = 'emerald-500',
  size = 'medium',
}) => {
  const variantNewTypeSize = {
    medium: 'w-[20px] h-[20px]',
    small: 'w-[16px] h-[16px]',
  };

  const newBadgePosition =
    size === 'small' ? 'mt-[-2px] ml-[-8px]' : 'mt-[-10px] mr-[-10px]';

  if (variant === 'dot') {
    return (
      <View
        className={`${dotPosition} mt-[-2px] mr-[-2px] w-[4px] h-[4px] rounded-full`}
        style={{ backgroundColor: getColor(color) }}
      />
    );
  }

  if (variant === 'new') {
    return (
      <View
        className={`${variantNewTypeSize[size]} ${newBadgePosition} ${dotPosition} bg-blue-500 rounded-full justify-center items-center`}
      >
        <Text
          face={'caption'}
          weight={'semibold'}
          size={size === 'medium' ? 'medium' : 'small'}
          textColor={'white'}
        >
          N
        </Text>
      </View>
    );
  }
};
